<template>
<div class="fakebody">
  
  <div class="top">
    <h1>{{ msg }}</h1>

    <h1>interaction crud vue.js</h1>
    <button @click.prevent="fetchUsers">fetch</button>

  </div>

  <ul>
    <li v-for="user, idx in users" :key="idx">
      <span class="li__username">{{ user.username }}</span>
      <form action="">
        <button class="li__modif" @click.prevent="modifUser(user.username)">modifier</button>
      </form>
      <button class="li__delete" @click.prevent="deleteUser(user.username)">Delete</button>
    </li>
  </ul>

  <div class="bottom_forms">
    <input class="bottom_forms__child" v-model="modifName" placeholder="modif name">
    <form class="bottom_forms__child" action="">
      <input v-model="addnew" placeholder="new name">
      <button @click.prevent="addUser">add</button>
    </form>
  </div>

</div>
</template>



<script>
  import { ref } from 'vue'
  export default {
    name: 'helloWorld',
    props: {
      msg: String
    },
    setup () {
      //const users = ref([{username:'testone'}, {username:'testtwo'}])
      const users = ref([])
      const addnew = ref('')
      const modifName = ref('')

      const fetchUsers = () => {
        fetch('http://localhost:8080/users')
        .then(res => res.json())
        .then(json => users.value = json)
        .catch(err => console.log(err))
      }

      const addUser = () => {

        
        const requestOptions = {
          method: "POST",
          headers: { "Content-Type": "application/json" },
          body: JSON.stringify({username: addnew.value})
        };
        fetch("http://localhost:8080/users", requestOptions)
          .then(response => response.json())
          .then(data => (users.value.push(data)));

      }

      const deleteUser = (username) => {
        //users.value.push({username: addnew})
        console.log("http://localhost:8080/users/"+username)
        const requestOptionsdelete = {
          method: "DELETE"
        };
        fetch("http://localhost:8080/users/"+username, requestOptionsdelete)
          .then(() => {
            const idx = users.value.findIndex((user) => user.username == username)
            users.value.splice(idx, 1)
          })
      }



      const modifUser = (oldUserName) => {
        console.log("http://localhost:8080/users/"+oldUserName);

        console.log(modifName.value);

        const requestOptionsModif = {
          method: "PUT",
          headers: { "Content-Type": "application/json" },
          body: JSON.stringify({username: modifName.value})
        };
        fetch("http://localhost:8080/users/"+oldUserName, requestOptionsModif)
          .then(response => response.json())
          //.then(data => (this.postId = data.id));
          .then(data => {
            const idx = users.value.findIndex((user) => user.username == oldUserName)
            users.value[idx] = data
          })

      }

      
      
      return {
        users,
        addnew,
        modifName,
        fetchUsers,
        addUser,
        deleteUser,
        modifUser
      }
    }
  }
</script>



<style>
:root{
  --blue:rgba(117, 117, 255, 0.5);
}
body{
  margin: 0;
  background-color: rgb(48, 48, 48);
  color: white;
}
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  margin: 0px;
}
.fakebody{
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  min-height: 100vh;
}
.top{
  background-color: var(--blue);
  padding: 2rem 0;
}
.top h1{
  margin: 0;

}
ul{
  padding: 0;
  margin: 2rem auto;
  display: flex;
  flex-direction: column;
  width: max-content;
}
li{
  margin: 0;
  padding: 0.5rem;
  list-style-type: none;
  background-color: rgba(0, 0, 0, 0.3);
  display: flex;
  justify-content: flex-end;
  border: 1px solid var(--blue);
  border-bottom: none;
  box-sizing: border-box;
}
li:last-child{
  border-bottom: 1px solid var(--blue);
  border-bottom-left-radius: 1rem;
  border-bottom-right-radius: 1rem;
}
li:first-child{
  border-top-left-radius: 1rem;
  border-top-right-radius: 1rem;
}
.li__username{
  margin: 0 1rem;
}
.li__modif{
  background-color: var(--blue);
  border: 1px solid rgba(255, 255, 255, 0.3);
  color:white;
  border-radius: 0.2rem;
}
.li__modif:hover{
  background-color: rgba(117, 117, 255, 0.9);
}
.li__delete{
  background-color: rgba(255, 0, 0, 0.3);
  border: 1px solid rgba(255, 255, 255, 0.3);
  color:white;
  margin-left: 1rem;
  border-radius: 0.2rem;
}
.li__delete:hover{
  background-color: rgba(255, 0, 0, 0.6);
}
.bottom_forms{
  display: flex;
  justify-content: center;
  background-color: var(--blue);
  padding: 1rem 1rem 4rem 1rem;
}
.bottom_forms__child:first-child{
  margin-right: 1rem;
}
</style>
